VERSION 5.00
Begin VB.Form ViewerForm 
   Caption         =   "Viewer []"
   ClientHeight    =   5685
   ClientLeft      =   1140
   ClientTop       =   1515
   ClientWidth     =   8715
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5685
   ScaleWidth      =   8715
   Begin VB.VScrollBar vbar 
      Height          =   1335
      Left            =   3960
      TabIndex        =   7
      Top             =   0
      Width           =   255
   End
   Begin VB.HScrollBar hbar 
      Height          =   255
      Left            =   2280
      TabIndex        =   6
      Top             =   1320
      Width           =   1575
   End
   Begin VB.PictureBox picScroller 
      Height          =   1215
      Left            =   2280
      ScaleHeight     =   1155
      ScaleWidth      =   1515
      TabIndex        =   4
      Top             =   0
      Width           =   1575
      Begin VB.PictureBox picImage 
         AutoSize        =   -1  'True
         BorderStyle     =   0  'None
         Height          =   975
         Left            =   0
         ScaleHeight     =   975
         ScaleWidth      =   1335
         TabIndex        =   5
         Top             =   0
         Width           =   1335
      End
   End
   Begin VB.ComboBox PatternCombo 
      Height          =   315
      Left            =   0
      TabIndex        =   3
      Text            =   "Combo1"
      Top             =   3600
      Width           =   2175
   End
   Begin VB.DriveListBox DriveList 
      Height          =   315
      Left            =   0
      TabIndex        =   2
      Top             =   0
      Width           =   2175
   End
   Begin VB.DirListBox DirList 
      Height          =   1155
      Left            =   0
      TabIndex        =   1
      Top             =   360
      Width           =   2175
   End
   Begin VB.FileListBox FileList 
      Height          =   1845
      Left            =   0
      TabIndex        =   0
      Top             =   1560
      Width           =   2175
   End
End
Attribute VB_Name = "ViewerForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' The currently displayed file.
Private m_FileName As String

' For deleting files.
Private Type SHFILEOPSTRUCT
    hwnd As Long
    wFunc As Long
    pFrom As String
    pTo As String
    fFlags As Integer
    fAnyOperationsAborted As Long
    hNameMappings As Long
    lpszProgressTitle As Long '  only used if FOF_SIMPLEPROGRESS
End Type
Private Declare Function SHFileOperation Lib "shell32.dll" Alias "SHFileOperationA" (lpFileOp As SHFILEOPSTRUCT) As Long
Private Const FO_DELETE = &H3
Private Const FOF_ALLOWUNDO = &H40
Private Const FOF_NOCONFIRMATION = &H10             '  Don't prompt the user.

' For setting wallpaper.
Private Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, ByVal lpvParam As Any, ByVal fuWinIni As Long) As Long
Private Const SPI_SETDESKWALLPAPER = 20

' For creating temporary file names.
Private Declare Function GetTempFileName Lib "kernel32" Alias "GetTempFileNameA" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFileName As String) As Long
Private Declare Function GetTempPath Lib "kernel32" Alias "GetTempPathA" (ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long

Private Function TempFile(ByVal prefix As String) As String
Dim Path As String
Dim name As String
Dim length As Long

    Path = Space$(1024)
    length = GetTempPath(Len(Path), Path)
    Path = Left$(Path, length)

    name = Space$(1024)
    GetTempFileName Path, prefix, 0, name

    length = InStr(name, Chr$(0)) - 1
    TempFile = Left$(name, length)
End Function

Private Sub DirList_Change()
    FileList.Path = DirList.Path
End Sub

Private Sub DriveList_Change()
    'On Error GoTo DriveError
    DirList.Path = DriveList.Drive
    Exit Sub

DriveError:
    DriveList.Drive = DirList.Path
    Exit Sub
End Sub


Private Sub FileList_Click()
    On Error GoTo LoadPictureError

    m_FileName = FileList.Path
    If Right$(m_FileName, 1) <> "\" Then m_FileName = m_FileName & "\"
    m_FileName = m_FileName & FileList.FileName
    Caption = "Viewer [" & m_FileName & "]"

    picImage.Picture = LoadPicture(m_FileName)
    ArrangeScrollbars

    Exit Sub

LoadPictureError:
    Beep
    MousePointer = vbDefault
    Caption = "Viewer [Invalid picture]"
    m_FileName = ""
    picImage.Picture = Nothing
    vbar.Value = 0
    hbar.Value = 0
    vbar.Visible = False
    hbar.Visible = False
    Exit Sub
End Sub
' Process keypresses.
' Delete    - Move the file into the wastebasket.
' Backspace - Kill the file.
' F5        - Hide/show the file selection controls.
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
Dim op As SHFILEOPSTRUCT

    On Error GoTo KeyError
    If KeyCode = vbKeyDelete Then
        ' Move the file into the wastebasket.
        With op
            .wFunc = FO_DELETE
            .pFrom = FileList.Path & "\" & FileList.FileName
            .fFlags = _
                FOF_ALLOWUNDO Or _
                FOF_NOCONFIRMATION
        End With
        SHFileOperation op

        picImage.Picture = Nothing
        vbar.Value = 0
        hbar.Value = 0
        vbar.Visible = False
        hbar.Visible = False
    ElseIf KeyCode = vbKeyBack Then
        ' Delete the file permanently.
        Kill FileList.Path & "\" & FileList.FileName

        picImage.Picture = Nothing
        vbar.Value = 0
        hbar.Value = 0
        vbar.Visible = False
        hbar.Visible = False
    ElseIf KeyCode = vbKeyF5 Then
        If picScroller.Left = 0 Then
            picScroller.Left = 2 * DriveList.Left + DriveList.Width
        Else
            picScroller.Left = 0
        End If
        picScroller.Width = ScaleWidth - picScroller.Left
        Form_Resize
    End If
    Exit Sub

KeyError:
    MsgBox "Error " & Format$(Err.Number) & _
        vbCrLf & Err.Description
    Exit Sub
End Sub

' If the user presses Ctrl_D, set the picture as
' the desktop wallpaper.
Private Sub Form_KeyPress(KeyAscii As Integer)
Const KEY_CTRL_D = 4
Dim file_name As String

    If KeyAscii = KEY_CTRL_D Then
        KeyAscii = 0

        file_name = FileList.Path & "\" & FileList.FileName
        If UCase$(Right$(file_name, 4)) = ".BMP" Then
            SystemParametersInfo _
                SPI_SETDESKWALLPAPER, 0, _
                file_name, 0
        Else
            file_name = TempFile("tmp")
            file_name = Left$(file_name, Len(file_name) - 3) & "bmp"
            SavePicture picImage, file_name
            SystemParametersInfo _
                SPI_SETDESKWALLPAPER, 0, _
                file_name, 0
            Kill file_name
        End If
        Screen.MousePointer = vbDefault
    End If
End Sub
Private Sub Form_Load()
    KeyPreview = True

    PatternCombo.AddItem "Bitmaps (*.bmp)"
    PatternCombo.AddItem "GIF (*.gif)"
    PatternCombo.AddItem "JPEG (*.jpg)"
    PatternCombo.AddItem "Icons (*.ico)"
    PatternCombo.AddItem "Metafiles (*.wmf)"
    PatternCombo.AddItem "DIBs (*.dib)"
    PatternCombo.AddItem "Graphic (*.gif;*.jpg;*.ico;*.bmp;*.wmf;*.dib)"
    PatternCombo.AddItem "All Files (*.*)"
    PatternCombo.ListIndex = PatternCombo.ListCount - 2
End Sub

' Set scroll bar parameters if necessary.
Private Sub ArrangeScrollbars()
Dim need_hgt As Single
Dim need_wid As Single
Dim got_hgt As Single
Dim got_wid As Single
Dim need_hbar As Boolean
Dim need_vbar As Boolean

    ' See which scroll bars we need.
    need_wid = picImage.Width
    need_hgt = picImage.Height
    got_wid = ScaleWidth - picScroller.Left
    got_hgt = ScaleHeight - picScroller.Top

    ' See if we need the horizontal scroll bar.
    need_hbar = (got_wid < need_wid)
    If need_hbar Then
        got_hgt = got_hgt - hbar.Height
    End If

    ' See if we need the vertical scroll bar.
    need_vbar = (got_hgt < need_hgt)
    If need_vbar Then
        got_wid = got_wid - vbar.Width

        ' See if we did not need the horizontal
        ' scroll bar but we now do.
        If Not need_hbar Then
            need_hbar = (got_wid < need_wid)
            If need_hbar Then
                got_hgt = got_hgt - hbar.Height
            End If
        End If
    End If
    If got_hgt < 120 Then got_hgt = 120
    If got_wid < 120 Then got_wid = 120

    ' Display the needed scroll bars.
    If need_hbar Then
        hbar.Move picScroller.Left, got_hgt, got_wid
        hbar.Min = 0
        hbar.Max = got_wid - need_wid
        hbar.SmallChange = got_wid / 3
        hbar.LargeChange = picScroller.ScaleWidth
        hbar.Visible = True
    Else
        hbar.Value = 0
        hbar.Visible = False
    End If
    If need_vbar Then
        vbar.Move picScroller.Left + got_wid, 0, vbar.Width, got_hgt
        vbar.Min = 0
        vbar.Max = got_hgt - need_hgt
        vbar.SmallChange = got_hgt / 3
        vbar.LargeChange = picScroller.ScaleHeight
        vbar.Visible = True
    Else
        vbar.Value = 0
        vbar.Visible = False
    End If

    ' Arrange the window.
    picScroller.Move picScroller.Left, 0, got_wid, got_hgt
End Sub
Private Sub Form_Resize()
Const GAP = 60

Dim wid As Integer
Dim hgt As Integer

    If WindowState = vbMinimized Then Exit Sub

    wid = DriveList.Width
    DriveList.Move GAP, GAP, wid
    PatternCombo.Move GAP, ScaleHeight - PatternCombo.Height, wid
    
    hgt = (PatternCombo.Top - DriveList.Top - DriveList.Height - 3 * GAP) / 2
    If hgt < 100 Then hgt = 100
    DirList.Move GAP, DriveList.Top + DriveList.Height + GAP, wid, hgt
    FileList.Move GAP, DirList.Top + DirList.Height + GAP, wid, hgt

    ArrangeScrollbars
End Sub

Private Sub hbar_Change()
    picImage.Left = hbar.Value
End Sub

Private Sub hbar_Scroll()
    picImage.Left = hbar.Value
End Sub


Private Sub PatternCombo_Click()
Dim pat As String
Dim p1 As Integer
Dim p2 As Integer

    pat = PatternCombo.List(PatternCombo.ListIndex)
    p1 = InStr(pat, "(")
    p2 = InStr(pat, ")")
    FileList.Pattern = Mid$(pat, p1 + 1, p2 - p1 - 1)
End Sub
Private Sub picImage_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    MsgBox Left$(Hex$(picImage.Point(X, Y)) & "000000", 6)
End Sub
Private Sub vbar_Change()
    picImage.Top = vbar.Value
End Sub


Private Sub vbar_Scroll()
    picImage.Top = vbar.Value
End Sub


